<template>
  <div class="flex mt-4 justify-content-center">
    <h1>Manage notifications</h1>
  </div>
  <Message v-if="removeSucessful" severity="info">Notification deleted.</Message>
  <div class="flex mt-4">
    <div class="flex-2 mx-3">
      <Card>
        <template #title> Add notification</template>
        <template #content>
          <div class="flex-auto custom-form">
            <label for="title" class="font-bold block mb-3">Title</label>
            <InputText
              v-model="notification.title"
              inputId="title"
              placeholder="Enter notification title..."
              id="titleInput"
            />
          </div>
          <div class="flex-auto custom-form">
            <label for="description" class="font-bold block mb-2">Description</label>
            <Textarea
              v-model="notification.description"
              inputId="description"
              placeholder="Provide a detailed description of the notification... "
              rows="15"
              cols="60"
              id="descriptionInput"
            />
          </div>
          <div class="flex-auto custom-form right-auto">
            <Button label="Add" icon="pi pi-plus" @click="add" />
          </div>
          <div class="card">
            <Message v-if="!isFormValid" severity="error">Fill out all fields!</Message>
            <Message v-if="addSuccessful" severity="success">
              <a href="./overview">Added notification!</a>
            </Message>
          </div>
        </template>
      </Card>
    </div>
    <div class="flex-1 mx-3">
      <ScrollPanel style="width: 100%; height: 90rem; overflow-y: auto">
        <div class="grid-container">
          <div class="grid-item" v-for="(item, index) in store.notifications" :key="index">
            <Card class="mb-3">
              <template #header></template>
              <template #title>
                <h4>
                  <u
                    ><i>{{ index + 1 }}.</i> {{ item.title }}</u
                  >
                </h4>
              </template>
              <template #subtitle>
                <i> {{ formatDate(item.datePosted) }} </i>
                <Divider></Divider>
              </template>
              <Divider></Divider>
              <template #content>
                <p>{{ item.description }}</p>
              </template>
              <template #footer>
                <Button
                  icon="pi pi-trash"
                  severity="danger"
                  rounded
                  outlined
                  aria-label="Cancel"
                  @click="remove(index)"
                />
              </template>
            </Card>
            <div v-if="isLastItem(index)" style="height: 20rem"></div>
          </div>
        </div>
      </ScrollPanel>
    </div>
  </div>
</template>

<script setup lang="ts">
import Button from 'primevue/button';
import InputText from 'primevue/inputtext';
import Textarea from 'primevue/textarea';
import Message from 'primevue/message';
import Card from 'primevue/card';
import { useNotificationsStore } from '../../stores/notifications/notifications';
import type { Ref } from 'vue';
import type { Notification } from '../../stores/notifications/notification';
import { ref } from 'vue';
import ScrollPanel from 'primevue/scrollpanel';
import Divider from 'primevue/divider';

const store = useNotificationsStore();
const notification: Ref<Notification> = ref({
  title: '',
  description: '',
  datePosted: new Date(),
});

let isFormValid: Ref<Boolean> = ref(true);
let addSuccessful: Ref<Boolean> = ref(false);
let removeSucessful: Ref<Boolean> = ref(false);

function add(): void {
  isFormValid.value = !(!notification.value.title || !notification.value.description);

  if (isFormValid.value) {
    store.addNotification(notification.value);

    addSuccessful.value = true;
    const titleInput = document.getElementById('titleInput') as HTMLInputElement;
    const descriptionInput = document.getElementById('descriptionInput') as HTMLInputElement;

    if (titleInput) titleInput.value = '';
    if (descriptionInput) descriptionInput.value = '';

    setTimeout(() => {
      addSuccessful.value = false;
    }, 3000);
  }
}

function remove(index: number): void {
  store.removeNotification(index);
  removeSucessful.value = true;
  setTimeout(() => {
    removeSucessful.value = false;
  }, 3000);
}

function formatDate(date: Date): string {
  const day = date.getDate().toString().padStart(2, '0');
  const month = (date.getMonth() + 1).toString().padStart(2, '0');
  const year = date.getFullYear().toString();

  return `${day}. ${month}. ${year}`;
}

function isLastItem(index: number) {
  return index + 1 === store.notifications.length;
}
</script>

<style scoped>
.custom-form {
  margin-top: 10px;
}
</style>
